<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve the question 3 solution.</p>
		<button onclick="pushAndPop()">get stack behaviour of linked list</button>
		<p id="demo"></p>

		<script>
			function pushAndPop(){
                //node of the linked list
                class Node { 
                    // constructor 
                    constructor(element) 
                    { 
                        this.element = element; 
                        this.next = null
                    } 
                } 

                // linkedlist class 
                class LinkedList { 
                    constructor() { 
                        this.head = null; 
                        this.size = 0; 
                    }   

                    // adds an element at the end of list 
                    add(element) { 
                        // creates a new node 
                        var node = new Node(element); 
    
                        // to store current node 
                        var current; 
    
                        // if list is Empty add the element and make it head 
                        if (this.head == null) 
                            this.head = node; 
                        else {
                            current = this.head; 
    
                            // iterate to the end of the list 
                            while (current.next) { 
                                current = current.next; 
                            } 
                            // add node 
                            current.next = node;  
                            this.size++; 
                        }
                    }
                    
                    //push an element in front of linked list
                    push(ele) {
                        var node = new Node(ele);
                        node.next = this.head;
                        this.head = node;
                    }
                    

                    //function for pop the element
                    pop() {
                        this.head = this.head.next;
                    }

                    //function to get the nth element
                    getNth(n) {
                        var current = this.head;
                        var count = 0;
                        while(current.next) {
                            count++;

                            //check element
                            if(count == n) {
                                console.log(current.element);
                                break;
                            }
                            //if not matched
                            current = current.next;
                        }
                    }
                    //print the list
                    printList() { 
                        var curr = this.head; 
                        var str = ""; 
                        while (curr) { 
                            str += curr.element + " "; 
                            curr = curr.next; 
                        } 
                        console.log(str); 
                    } 

                     
                    }

                    var i;
                    var element;
                    var list = new LinkedList();
				    var linked_list_size = prompt("Please enter the size of linked list : ");
                    //insert the element in linked list
				    for(i=0;i<linked_list_size;i++) {
					    element = +(prompt(`Please enter the ${i+1} element of linked list: `));
					    list.add(element);
                    }
                    var ele = prompt("Please enter element which you want to push : ");
                    list.printList();
                    list.push(ele);
                    list.printList();
                    list.pop();
                    list.printList();
                    var n = prompt("Please enter which element you want : ");
                    list.getNth(n);
			}
		</script>

	</body>
</html>